Subject: Re: [PATCH] io_uring: Add io_uring command support for sockets

From: Breno Leitao <[email-masked]>
Date: Thu, 22 Jun 2023 08:02:37 -0700

On Thu, Jun 22, 2023 at 07:20:48AM +0200, Greg Kroah-Hartman wrote:
> On Wed, Jun 21, 2023 at 04:21:26PM -0700, Breno Leitao wrote:
> > Enable io_uring commands on network sockets. Create two new
> > SOCKET_URING_OP commands that will operate on sockets. Since these
> > commands are similar to ioctl, uses the _IO{R,W} helpers to embedded the
> > argument size and operation direction. Also allocates a unused ioctl
> > chunk for uring command usage.
> > 
> > In order to call ioctl on sockets, use the file_operations->uring_cmd
> > callbacks, and map it to a uring socket function, which handles the
> > SOCKET_URING_OP accordingly, and calls socket ioctls.
> > 
> > This patches was tested by creating a new test case in liburing.
> > Link: https://github.com/leitao/liburing/commit/3340908b742c6a26f662a0679c4ddf9df84ef431
> > 
> > Signed-off-by: Breno Leitao <[email-masked]>
> > ---
> 
> Isn't this a new version of an older patch?

Yes, this should have tagged as V2.

[1] https://lore.kernel.org/lkml/[email-masked]/#r

> > --- a/Documentation/userspace-api/ioctl/ioctl-number.rst
> > +++ b/Documentation/userspace-api/ioctl/ioctl-number.rst
> > @@ -361,6 +361,7 @@ Code  Seq#    Include File                                           Comments
> >  0xCB  00-1F                                                          CBM serial IEC bus in development:
> >                                                                       <mailto:[email-masked]>
> >  0xCC  00-0F  drivers/misc/ibmvmc.h                                   pseries VMC driver
> > +0xCC  A0-BF  uapi/linux/io_uring.h                                   io_uring cmd subsystem
> 
> This change is nice, but not totally related to this specific one,
> shouldn't it be separate?

This is related to this patch, since I am using it below, in the
following part:

	+#define SOCKET_URING_OP_SIOCINQ _IOR(0xcc, 0xa0, int)
	+#define SOCKET_URING_OP_SIOCOUTQ _IOR(0xcc, 0xa1, int)

Should I have a different patch, even if they are related?

> > +EXPORT_SYMBOL_GPL(uring_sock_cmd);
> 
> Did you forget the "io_" prefix?

Yes, I will rename the function.

Thanks for the review.